public class FractionalConstant implements IRealNumber
{
  private FractionalNumber constant;
  public FractionalConstant(int constant)
  {
    this.constant = new FractionalNumber(constant);
  }
  public FractionalConstant(int numerator, int denominator)
  {
    this.constant = new FractionalNumber(numerator, denominator);
  }
  public FractionalConstant(FractionalNumber constant)
  {
    this.constant = constant;
  }
  public FractionalConstant(NaturalNumber numerator, NaturalNumber denominator)
  {
    this.constant = new FractionalNumber(numerator, denominator);
  }
  public FractionalNumber approximate(int digits)
  {
    return constant;
  }
  public FractionalConstant invert()
  {
    return new FractionalConstant(constant.invert());
  }
}