import java.util.Scanner;
import java.util.ArrayList;
import java.lang.Math;
public class TranscendentalMath
{
  public static void main(String[] args)
  {
    Scanner in = new Scanner(System.in);
    
    String assignment = in.nextLine();    
    if (assignment.trim().equals("Part 1"))
    {
      int digits = in.nextInt();
      new EConstant().approximate(digits).print(digits);
      System.out.println();
      new ChampernowneConstant().approximate(digits).print(digits);
      System.out.println();
    }
    else if (assignment.trim().equals("Part 2"))
    {
      int firstN = in.nextInt();
      NaturalNumber first = new NaturalNumber(0);
      NaturalNumber factor = new NaturalNumber(10).pow(6); //1000000
      for (int i = 0; i < firstN; i++)
      {
        first = first.multiply(factor).add(in.nextInt());
      }
      int secondN = in.nextInt();
      NaturalNumber second = new NaturalNumber(0);
      for (int i = 0; i < firstN; i++)
      {
        second = second.multiply(factor).add(in.nextInt());
      }
      new FractionalNumber(first, second).printSimplified();
      System.out.println();
    }
    else if (assignment.trim().equals("Part 3"))
    {
      int order = in.nextInt();
      int h = in.nextInt();
      int n = in.nextInt();
      Polynomial p = Polynomial.approximate(new EPower(n),
                                            order,
                                            new FractionalConstant(new FractionalNumber(1, 2).pow(h)));
      int numerator = in.nextInt();
      int denominator = in.nextInt();
      int digits = in.nextInt();
      p.compute(new FractionalConstant(numerator, denominator)).approximate(digits).print(digits);
      System.out.println();
    }
  }
}
























































